Whamcloud - gitweb
Fixes to allow the harness to build v1_4_5_91.
[fs/lustre-release.git] / lustrecvs
1 #!/bin/sh
2
3 LC_COLLATE="C"
4 progname="${0##*/}"
5
6 warn ()
7 {
8     [ "$1" ] && echo >&2
9     [ "$1" ] && echo "$progname: $1" >&2
10     [ "$1" ] && echo >&2
11 }
12
13 fatal ()
14 {
15     warn "$2"
16     exit "$1"
17 }
18
19 usage ()
20 {
21     cat <<EOF
22 Usage: $progname <lustretag>
23   where <lustretag> is a tag of the lustre-core module
24 EOF
25 }
26
27 if [ -z "$LUSTRECVS_UPDATED" ] ; then
28     echo "$progname: updating lustrecvs"
29     cvs up -l || fatal 1 "Error updating lustrecvs"
30     export LUSTRECVS_UPDATED=yes
31     exec "$0" "$@"
32 fi
33
34 [ "$1" = "-r" ] && shift
35
36 buildtag="HEAD"
37 lustretag="$1"
38 shift
39
40 if [ "$*" ] ; then
41     usage >&2
42     exit 1
43 fi
44
45
46 case "$lustretag" in
47     '')
48         warn "a lustretag is required."
49         usage >&2
50         exit 1
51         ;;
52     --help | -h)
53         usage
54         exit 0
55         ;;
56
57     b1_4_newconfig*|b_newconfig_rdmarouting*|b1_4_mountconf*)
58         buildtag="b_lnet"
59         ;;
60
61     # These releases use the b_lnet build
62     v1_4_5_91)
63         buildtag="b_lnet"
64         ;;
65
66     # Apparently these releases did not get build tagged for them...
67     v1_2_8|v1_4_0) 
68         buildtag="HEAD"
69         ;;
70         
71     v*) buildtag=$lustretag ;;
72
73     # this is the branch table
74     # keep this list sorted alphabetically!
75
76     *)
77         buildtag="HEAD"
78         ;;
79
80 esac
81
82 error_modules=
83 cvs_cmd ()
84 {
85     dir="$1"
86     module="$2"
87     tag="$3"
88     cotag=""
89     update=""
90
91     if [ "$tag" = "HEAD" ] ; then
92         cotag=""
93         uptag="-A"
94     elif [ "$tag" ] ; then
95         cotag="-r $tag"
96         uptag="-r $tag"
97     else
98         # silently skip if no tag was specified
99         return
100     fi
101
102     if [ -d "$dir" ] ; then
103         echo "$progname: Updating $dir to $tag"
104         ( cd "$dir" && cvs up -dP $uptag )
105     else
106         echo "$progname: Checking out $dir from $tag"
107         cvs co -P $cotag -d "$dir" "$module"
108     fi
109     if [ $? != 0 ] ; then
110         error_modules="$dir $error_modules"
111     fi
112 }
113
114 cvs_cmd build lustre-build "$buildtag"
115
116 if [ -f build/buildcvs ] ; then
117     . build/buildcvs
118 else
119     fatal 1 "build/buildcvs does not exist; not updating other modules."
120 fi
121
122 if [ "$error_modules" ] ; then
123     fatal 1 "There were errors checking out the following directories: $error_modules"
124 fi